aboutsummaryrefslogtreecommitdiff
path: root/gen/prop/stc
diff options
context:
space:
mode:
authorThomas Voss <mail@thomasvoss.com> 2024-04-11 21:08:35 +0200
committerThomas Voss <mail@thomasvoss.com> 2024-04-11 21:08:35 +0200
commita1749aa9bbe5abc10bde30b2bf1210091e0ee2d4 (patch)
treeea5127335714867e2bdd0478964d154e42bbbebf /gen/prop/stc
parentb303c3bb16e8d312df47bb01007de741bff23b77 (diff)
Add uprop_get_s[ult]c()
Diffstat (limited to 'gen/prop/stc')
-rwxr-xr-xgen/prop/stc45
1 files changed, 45 insertions, 0 deletions
diff --git a/gen/prop/stc b/gen/prop/stc
new file mode 100755
index 0000000..42dca19
--- /dev/null
+++ b/gen/prop/stc
@@ -0,0 +1,45 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_stc.c
+
+gawk '
+BEGIN {
+ FS = ";"
+
+ print "/* This file is autogenerated by gen/prop/stc; DO NOT EDIT. */"
+ print ""
+ print "#include \"__bsearch.h\""
+ print "#include \"macros.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+length($15) > 0 && $13 != $15 && $1 != $15 {
+ map[strtonum("0X" $1)] = strtonum("0X" $15)
+}
+
+END {
+ print "static const struct {"
+ print "\trune k, v;"
+ print "} lookup[] = {"
+
+ for (i = 0x100; i <= 0x10FFFF; i++) {
+ if (!map[i])
+ continue
+ printf "\t{RUNE_C(0x%06X), RUNE_C(0x%06X)},\n", i, map[i]
+ }
+
+ print "};"
+ print ""
+ print "__MLIB_DEFINE_BSEARCH_KV(rune, lookup, uprop_get_suc(ch))"
+ print ""
+ print "rune"
+ print "uprop_get_stc(rune ch)"
+ print "{"
+ print "\treturn mlib_lookup_kv(ch);"
+ print "}"
+}
+' data/UnicodeData.txt